#include "stdafx.h"
#include "ResCopy.h"
#include "ResCopyDlg.h"
#include "..\Videomod.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CResCopyApp, CWinApp)
END_MESSAGE_MAP()

CResCopyApp::CResCopyApp()
{
}

CResCopyApp theApp;

BOOL CResCopyApp::InitInstance()
{
  //Parse the command line
  CCommandLineInfo cmdLineInfo;
  ParseCommandLine(cmdLineInfo);
  if (cmdLineInfo.m_strFileName.GetLength())
  {
    //Just write the results to the file as specified on the command line
    CStdioFile outFile;
    if (outFile.Open(cmdLineInfo.m_strFileName, CFile::typeText | CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite))
    {
      //First enumerate all the display devices
      CDisplayDevices devices;
      CAvailableDisplayDevices::Get(devices);
      for (int i=0; i<devices.GetSize(); i++)
      {
        //Write out the details of the device
        CString sDevice;
        CDisplayDevice& device = devices.ElementAt(i);
        sDevice.Format(_T("%s %s %s %X\n"), device.m_sDeviceName.operator LPCTSTR(), device.m_sDeviceString.operator LPCTSTR(), device.m_sDeviceID.operator LPCTSTR(), device.m_dwStateFlags);
        outFile.WriteString(sDevice);
      
        //then all the display modes for that display device
        CDisplayModes modes;
        CAvailableDisplayModes::GetAvailable(device.m_sDeviceName, modes);
        for (int j=0; j<modes.GetSize(); j++)
        {
          CString sMode;
          CDisplayMode& mode = modes.ElementAt(j);
          sMode.Format(_T(" %d x %d, %d, %d\n"), mode.m_dwWidth, mode.m_dwHeight, mode.m_dwBitsPerPixel, mode.m_dwFrequency);
          outFile.WriteString(sMode);
        }
      }
    }
  }
  else
  {
    //Display the GUI dialog
	  CResCopyDlg dlg;
	  m_pMainWnd = &dlg;
	  dlg.DoModal();
  }

	return FALSE;
}
