#include "stdafx.h"
#include "ResCopy.h"
#include "ResCopyDlg.h"
#include "..\Videomod.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CResCopyDlg::CResCopyDlg(CWnd* pParent)	: CDialog(CResCopyDlg::IDD, pParent),
	                                        m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME))
{
}

void CResCopyDlg::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
	CDialog::DoDataExchange(pDX);
	
	DDX_Control(pDX, IDC_MODES, m_ctrlModes);
}

BEGIN_MESSAGE_MAP(CResCopyDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

BOOL CResCopyDlg::OnInitDialog()
{
  //Let the base class do its thing
	CDialog::OnInitDialog();

  //Setup the icons for the dialog
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

  //First enumerate all the display devices
  CDisplayDevices devices;
  CAvailableDisplayDevices::Get(devices);
  for (int i=0; i<devices.GetSize(); i++)
  {
    //first add out the details of the device to the tree control
    CString sDevice;
    CDisplayDevice& device = devices.ElementAt(i);
    sDevice.Format(_T("%s %s %s %X"), device.m_sDeviceName.operator LPCTSTR(), device.m_sDeviceString.operator LPCTSTR(), device.m_sDeviceID.operator LPCTSTR(), device.m_dwStateFlags);
    HTREEITEM hDevice = m_ctrlModes.InsertItem(device.m_sDeviceName, 0, 0);
    CString sItem;
    sItem.Format(_T("DeviceString: %s"), device.m_sDeviceString.operator LPCTSTR());
    m_ctrlModes.InsertItem(sItem, 0, 0, hDevice);
    sItem.Format(_T("DeviceID: %s"), device.m_sDeviceID.operator LPCTSTR());
    m_ctrlModes.InsertItem(sItem, 0, 0, hDevice);
    sItem.Empty();
    if (device.m_dwStateFlags & DISPLAY_DEVICE_ATTACHED_TO_DESKTOP)
      m_ctrlModes.InsertItem(_T("Attached to Desktop"), 0, 0, hDevice);
    if (device.m_dwStateFlags & DISPLAY_DEVICE_MIRRORING_DRIVER)
      m_ctrlModes.InsertItem(_T("Invisible Pseudo monitor"), 0, 0, hDevice);
    if (device.m_dwStateFlags & DISPLAY_DEVICE_MODESPRUNED)
      m_ctrlModes.InsertItem(_T("Has more display modes than its output device supports"), 0, 0, hDevice);
    if (device.m_dwStateFlags & DISPLAY_DEVICE_PRIMARY_DEVICE)
      m_ctrlModes.InsertItem(_T("Primary desktop"), 0, 0, hDevice);
    if (device.m_dwStateFlags & DISPLAY_DEVICE_REMOVABLE)
      m_ctrlModes.InsertItem(_T("Removable"), 0, 0, hDevice);
    if (device.m_dwStateFlags & DISPLAY_DEVICE_VGA_COMPATIBLE)
      m_ctrlModes.InsertItem(_T("VGA Compatible"), 0, 0, hDevice);

    //Add then all the modes for that device to the combo box
    CDisplayModes modes;
    CAvailableDisplayModes::GetAvailable(device.m_sDeviceName, modes);
    HTREEITEM hModes = m_ctrlModes.InsertItem(_T("Display Modes"), 0, 0, hDevice);
    for (int i=0; i<modes.GetSize(); i++)
    {
      CDisplayMode& mode = modes.ElementAt(i);
      sItem.Format(_T("Resolution:%dx%d, Depth:%d, Frequency:%d"), mode.m_dwWidth, mode.m_dwHeight, mode.m_dwBitsPerPixel, mode.m_dwFrequency);
      m_ctrlModes.InsertItem(sItem, 0, 0, hModes);
    }
  }
  	
	return TRUE;
}

void CResCopyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); //device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		//Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CResCopyDlg::OnQueryDragIcon()
{
	return reinterpret_cast<HCURSOR>(m_hIcon);
}
